var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  defineMacro: () => defineMacro,
  defineMacroProvider: () => defineMacroProvider,
  isMacro: () => isMacro,
  isMacroProvider: () => isMacroProvider
});

// ../../node_modules/tsup/assets/cjs_shims.js
var importMetaUrlShim = typeof document === "undefined" ? new (require("url")).URL("file:" + __filename).href : document.currentScript && document.currentScript.src || new URL("main.js", document.baseURI).href;

// src/macro/macro.ts
var import_shared = __toModule(require("@typed-macro/shared"));
function macro(meta, handler) {
  return {
    name: meta.name,
    handler: normalizeHandler(handler),
    types: renderMacroTypes(meta),
    version: import_shared.VERSION,
    __is_macro: true
  };
}
function isMacro(o) {
  var _a;
  return (_a = o == null ? void 0 : o.__is_macro) != null ? _a : false;
}
function normalizeHandler(handler) {
  if (!(0, import_shared.isFunction)(handler))
    throw new Error("macro handler should be a function");
  if ((0, import_shared.isAsyncFunction)(handler))
    throw new Error("macro handler should not be an async function");
  if (handler.length === 0)
    throw new Error("macro handler should have at least one parameter");
  return (0, import_shared.isGeneratorFunction)(handler) ? function* (call) {
    yield* handler(call.ctx, call.babel, call.helper);
  } : function* (call) {
    yield call.ctx.args;
    handler(call.ctx, call.babel, call.helper);
  };
}
function renderMacroTypes({ name, types, signatures }) {
  return [
    types.join("\n"),
    signatures.map((s) => s.comment ? `/** ${s.comment} */
export function ${name}${s.signature}` : `export function ${name}${s.signature}`).join("\n")
  ].filter((t) => !!t).join("\n");
}

// src/macro/builder.ts
var import_shared2 = __toModule(require("@typed-macro/shared"));
function defineMacro(name) {
  if (!(0, import_shared2.validateFnName)(name))
    throw new Error(`'${name}' is not a valid macro name!`);
  const meta = {
    name,
    signatures: [],
    types: []
  };
  const builder = {
    withCustomType(typeDefinition) {
      meta.types.push(typeDefinition);
      return builder;
    },
    withSignature(signature, comment) {
      if (!signature)
        throw new Error(`Signature for macro '${name}' can not be an empty string`);
      meta.signatures.push({ signature, comment });
      return builder;
    },
    withHandler(handler) {
      if (meta.signatures.length === 0)
        throw new Error(`Please call .withSignature() before .withHandler() to specify at least one signature for macro '${name}'`);
      return macro(meta, handler);
    }
  };
  return builder;
}

// src/provider/provider.ts
var import_shared3 = __toModule(require("@typed-macro/shared"));
function isMacroProvider(o) {
  var _a;
  return (_a = o == null ? void 0 : o.__is_macro_provider) != null ? _a : false;
}
function macroProvider(provider) {
  provider.__is_macro_provider = true;
  provider.version = import_shared3.VERSION;
  return provider;
}

// src/provider/builder.ts
function defineMacroProvider(raw) {
  return macroProvider(raw);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineMacro,
  defineMacroProvider,
  isMacro,
  isMacroProvider
});
